#!/bin/bash

# Illustration of how to use the OSEPP accelerometer module with the sensor20
# program.  Note that it's a 3.3v chip, but OSEPP gives it in a 5-volt module with
# a built-in regulator.

LOOP=1
trap "LOOP=0" INT

POW="AN5"	# Pin supplying power to the accelerometer
SDA="AN7"
SCL="AN6"

# sensor20 will accept these as environment variables
export SDA
export SCL

./sensor20 PING $POW:Z D:100 $POW:1 D:100 1d[00] 1d[31]=0b 1d[2d]=08 || exit 1

LOOP=1

while [ $LOOP -gt 0 ]
do
	LINE=$(./sensor20 1D[32]:6)

	set -- ${LINE:0:4} ${LINE:4:4} ${LINE:8:4}

	X=$((0x${1:2:2}${1:0:2}))
	Y=$((0x${2:2:2}${2:0:2}))
	Z=$((0x${3:2:2}${3:0:2}))

	[ $X -gt 32767 ] && ((X=(X&0x7fff)-32768))
	[ $Y -gt 32767 ] && ((Y=(Y&0x7fff)-32768))
	[ $Z -gt 32767 ] && ((Z=(Z&0x7fff)-32768))

	X=$((((X * 39)/10)))
	Y=$((((Y * 39)/10)))
	Z=$((((Z * 39)/10)))

	SZ=" ";	SY=" "; SZ=" "
	[ $X -lt 0 ] && SZ="-" && X=$((-X))
	[ $Y -lt 0 ] && SY="-" && Y=$((-Y))
	[ $Z -lt 0 ] && SZ="-" && Z=$((-Z))

	printf "%s $SX%d.%03d $SY%d.%03d $SZ%d.%03d\n" LINE		\
		$((X/1000)) $((X%1000)) $((Y/1000)) $((Y%1000))	$((Z/1000)) $((Z%1000))
#	echo $LINE $((X/1000)). $Y $Z

	if [ "$TEST" == "01" ]
	then
		TEST="81"
	else
		TEST="01"
	fi
done
