#!/bin/bash

export SCL=AN5
export SDA=AN4
ADDR=74

while [ "$#" -ge 2 ]
do

CAP=$1 	# Higher values are less sensitive
INT=$2	# Lower values are less sensitive

bswap () {
	local N=0

	while [ $((N+2)) -le "${#1}" ]
	do
		printf "%s" ${1:$((N+2)):2}${1:$N:2}
		let N=N+4
	done

	echo ${1:$N}
}


HCAP=$(bswap $(printf "%02x" $CAP) )
HINT=$(bswap $(printf "%04x" $INT) )

#echo "CAP value of $CAP => $HCAP"
#echo "INT value of $INT => $HINT"

INIT="${ADDR}[06]=${CAP}${CAP}${CAP}${CAP}${INT}${INT}${INT}${INT}"
DATABYTES="${ADDR}[40]:8"
OFFBYTES="${ADDR}[48]:4"
DATACMD=01
OFFCMD=02

TEMP="$*"

#set -- `./sensor20 $INIT 74[00]=01 74[00] $DATABYTES`
set -- `./sensor20 $INIT 74[00]=02 74[00] $OFFBYTES 74[00]=01 74[00] $DATABYTES`

if [ "$1" != "00" ]
then
	set -- $TEMP
	continue
fi

echo "Raw	$*"

set -- $TEMP
shift 2
done

exit 0
echo "Red	${1:0:4}=>${1:2:2}${1:0:2}"
echo "Green	${1:4:4}=>${1:6:2}${1:4:2}"
echo "Blue	${1:8:4}=>${1:10:2}${1:8:2}"
echo "Clear	${1:12:4}=>${1:14:2}${1:12:2}"
