#!/bin/sh

# Shows how to read from the HIH6130 combination humidity and
# temperature sensor.

SCL=RA4
SDA=AN3
ADDR=27

DATA=$(./sensor20 PING --SCL $SCL --SDA $SDA ${ADDR}[00]:4)

HUMID=$((0x${DATA:0:4}))
TEMP=$((0x${DATA:4:4}))

case "$(( HUMID & 0xc000 ))" in
	0)	;;
	16384)	echo "Stale data" ; exit 1 ;;
	32768)	echo "Command Mode" ; exit 1 ;;
	*)	echo "Diagnostic" ; exit 1 ;;	
esac

TEMP=$((TEMP>>2))

echo Degrees C:  $(( (TEMP*165)/((1<<14)-1) - 40))
echo Percent Humidity: $(( (HUMID*100)/((1<<14)-1) ))
