#!/bin/sh

# Illustration of how to use the HMC5883L magnetometer IC with the sensor20 ic.
# Note that this is a 3.3 volt chip.  Do not power it directly from
# the 5V bus.  The pull-up resistors must also be attached to 3.3v.

export SDA=AN5
export SCL=AN6


CRA=00
CRB=01
MODE=02

DATA=$(./sensor20 1e[$CRA]=70 1e[$CRB]=a0 1e[$MODE]=01 D:6 1e[03]:6)

X="$((0x${DATA:0:4}))"
Y="$((0x${DATA:4:4}))"
Z="$((0x${DATA:8:4}))"

#printf "%s %04x %04x %04x\n" $DATA $X $Y $Z

[ $X -gt 32767 ] && ((X=(X&0x7fff) - 32768))
[ $Y -gt 32767 ] && ((Y=(Y&0x7fff) - 32768))
[ $Z -gt 32767 ] && ((Z=(Z&0x7fff) - 32768))

echo $X $Y $Z
